﻿Type=Activity
Version=2.22
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim Blib As BasicLibIDE
	Dim StepState As Boolean
	Dim BreakLine As Int
	Dim Program As String
	Dim FirstRunFlag As Boolean
	Dim SavedData(0) As String
	
	Dim ScriptVersion As Double
	' 1.3 Removed limit of 6 menu items
	' 1.4	added InputFile and InputNumber dialogs
	'			added OpenMenu, CloseMenu, FillArray, SortArray, SearchArray 
	' 1.5	no changes but re-versioned to match the latest BasicIDE library
	' 1.6	no changes but re-versioned to match the latest BasicIDE library
	' 1.7	no changes but re-versioned to match the latest BasicIDE library
	' 1.8	added custom area for new functions to be added by BasicLibIDE.AddSysCalls
	'			added call of AddNewSysCalls to Activity_Create
	' 1.9	added test args() for bug fix in BasicIDE v1.9
	' 1.91	no changes but re-versioned to match the latest BasicIDE library
	' 1.92	no changes but re-versioned to match the latest BasicIDE library
	' 1.92	no changes but re-versioned to match the latest BasicIDE library
	' 1.93	no changes but re-versioned to match the latest BasicIDE library
	' 1.94	no changes but re-versioned to match the latest BasicIDE library
	' 1.95	SysCalls module added. SysCalls.InitializeSysWords called in Activity_Create
	' 1.96	no changes but re-versioned to match the latest BasicIDE library
	' 1.97	no changes but re-versioned to match the latest BasicIDE library
	ScriptVersion = 1.95 
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Dim viewmap As Map ' holds all views
	
	Dim bmp As Bitmap ' one bitmap	
	Dim draw As Canvas ' one canvas	
	Dim font As Typeface ' one typeface
	Dim istream As InputStream ' one in stream
	Dim ostream As OutputStream ' one out stream
	Dim timer1 As Timer '  one timer
	Dim arraysX As ArraysExtra
	
	Dim aw As Int ' screen width
	Dim ah As Int ' screen height
	Dim input ' last dialog input
	
	Dim nextmenuitem As Int
	Dim menuitems(0) As String
	
	Dim starting As Boolean ' used to detect and ignore first Ended event after the inital block has completed
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.Title = "Script window"
	aw = Activity.Width
	ah = Activity.Height
	
	nextmenuitem = 0
	Dim menuitems(6) As String

	font = Typeface.CreateNew(Typeface.DEFAULT, Typeface.STYLE_NORMAL)
	timer1.Initialize("Timer", 1000)
	Blib.Initialize("Blib")
	SysCalls.InitializeSysWords
	AddNewSysCalls
	Blib.StackDepth = 15
	Blib.Step = StepState
	Blib.BreakAtLine = BreakLine
	viewmap.Initialize
	ok = Blib.LoadCodeAsString(Program)
	If ok Then
		Dim args(3) As String
		args(0) = "Fred"
		args(1) = "Bill"
		args(2) = "Charlie"
		Blib.Run(args)
	Else
		Blib_Ended(Blib.ErrorString)
	End If
	
End Sub

Sub Activity_Resume
	' Can check GetFirstTime to see if it has run before and retrieve saved persistent data with GetSavedData
	If Blib.CanCall("Activity_Resume") Then ' check if the Sub exists
		Blib.Call("Activity_Resume", Null) ' can save persistent data with SetSavedData
	End If

End Sub

Sub Activity_Pause (UserClosed As Boolean)
	FirstRunFlag = False
	If Blib.CanCall("Activity_Pause") Then ' check if the Sub exists
		Dim params(1) As String
		params(0) = UserClosed
		Blib.Call("Activity_Pause", params) ' can save persistent data with SetSavedData
	End If
	timer1.Enabled = False
End Sub

#Region BasicLib Events

Sub Blib_Loaded(error As String) 'Error is an empty string if the script loaded without error	
	If error <> "" Then
		msg = "Error at line " & Blib.LineNumber & CRLF
		msg = msg & "Code - " & Blib.ProgramLine(Blib.LineNumber) 
		msg = msg & "Error - " & Blib.ErrorString 
		Msgbox(msg,"Error loading script")
		Activity.Finish
	End If
End Sub

Sub Blib_Starting 'The script has initialised its variables and is about to start executing
	starting = True
End Sub

Sub Blib_Break(linenumber As Int) 'The script has stopped at linenumber
	msg = "Break at line " & Blib.linenumber & " : "  & Blib.ProgramLine(Blib.linenumber) & CRLF
	msg = msg & "Step to step one line" & CRLF
	msg = msg & "Run to keep break" & CRLF
	msg = msg & "Cancel to clear break"	
	ret = Msgbox2(msg,"Break", "Step", "Run", "Cancel" & CRLF & "Break", Null)
	If ret = DialogResponse.NEGATIVE Then
			Blib.BreakAtLine = 0
		Else If ret = DialogResponse.POSITIVE Then
			Blib.Step = True
		Else If ret = DialogResponse.CANCEL Then
			Blib.Step = False			
		End If	
End Sub

Sub Blib_Stepped(linenumber As Int) 'The script has stepped to linenumber
	msg = "Stepped to line " & Blib.linenumber & " : "  & Blib.ProgramLine(Blib.linenumber) & CRLF
	msg = msg & "Continue stepping?"
	ret = Msgbox2(msg,"Stepped", "Yes", "No", "", Null)
	If ret <> DialogResponse.POSITIVE Then
		Blib.Step = False
	End If
	
End Sub

Sub Blib_Ended(error As String) 'Error is an empty string if the script terminated without error
	If starting AND error = "" Then ' don't stop after initial code block exits except on error
		starting = False
		Return
	End If
	If Blib.ErrorString <> "" Then
		msg = "Error at line " & Blib.LineNumber & CRLF
		msg = msg & "Code - " & Blib.ProgramLine(Blib.LineNumber) 
		msg = msg & "Error - " & Blib.ErrorString 
		Msgbox(msg,"Ended with error")
'	Else
'		Msgbox("Ended OK", "Ended")
	End If
	Activity.Finish
End Sub

Sub Blib_Message(message As String, subject As String)
	Msgbox(message, subject)
End Sub

#End Region

#Region Script support Subs

Sub AddView(o As Object, name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim v As View
	v = viewmap.Get(parent)
	If v.IsInitialized  Then
		If v Is Panel Then
			Dim p As Panel
			p = v
			p.AddView(o, left, top, width, height)
		End If
	Else
		Activity.AddView(o, left, top, width, height)
	End If
	viewmap.Put(name, o)
End Sub


#End Region

' Subs below are called by the running script
' Do Edit -> Outlining -> Collapse All then expand the regions below to conveniently see what functions are available
''<a name="top"></a>
''BASICIDE V2.8 HELP CONTENTS
''
''<a href="#device">Device Functions</a><p>
''<a href="#activity">Activity Functions</a><p>
''<a href="#events">Views and Events</a><p>
''<a href="#view">View Functions</a><p>
''<a href="#textview">TextView Functions</a><p>
''<a href="#edittext">EditText Functions</a><p>
''<a href="#check">Check, Radio and Toggle Functions</a><p>
''<a href="#timer">Timer Functions</a><p>
''<a href="#seekbar">SeekBar Functions</a><p>
''<a href="#scrollview">ScrollView Functions</a><p>
''<a href="#spinner">Spinner Functions</a><p>
''<a href="#listview">ListView Functions</a><p>
''<a href="#listandspin">ListView and Spinner Functions</a><p>
''<a href="#tabhost">TabHost Functions</a><p>
''<a href="#graphics">Graphics Functions</a><p>
''<a href="#arrays">Array Functions</a><p>
''<a href="#user">User Interaction Functions</a><p>
''<a href="#file">File Functions</a>

#Region Device functions
''<a name="device"></a>
''DEVICE FUNCTIONS
''
''Get the available width of the window.
'' Depending upon the device orientation this is not necessarily the same as the physical display width.
Sub WindowWidth
	Return aw
End Sub

''Get the available height of the window.
'' Depending upon the device orientation this is not necessarily the same as the physical display height.
Sub WindowHeight
	Return ah
End Sub

''Get the scaling value (density) for this device.
Sub ScreenScale
	Return GetDeviceLayoutValues.Scale
End Sub

''Get the layout values for this device in a comma separated string "width,height,density",
Sub GetLayoutValues
	Dim l As LayoutValues
	l = GetDeviceLayoutValues
	Return l.Width & "," & l.Height & "," & l.Scale
End Sub


#End Region

#Region Activity functions
''<a href="#top">Contents</a>
''<a name="activity"></a>
''ACTIVITY FUNCTIONS
''
''Returns true if this is the first time the initial code block program has been run.
''This is the equivalent of FirstTime in Activity_Create.
Sub GetFirstTime
	Return FirstRunFlag
End Sub

''Get a previously saved an array of persistent data that will survive activity destruction.
Sub GetSavedData(dataarrayname As String)
	Blib.SetArray(dataarrayname, SavedData)	
End Sub

''Save an array of data that will survive activity destruction.
Sub SetSavedData(dataarrayname As String)
	SavedData = Blib.GetArray(dataarrayname)	
End Sub

''Close the Activity and return to the editor
''Call this at the end of the initial code block for a program that does not support events otherwise the
''program will be left waiting for an event that won't come and the back button will be needed to close it.
''A program that does support events can end by calling AppClose or this.
Sub ActivityFinish
	Activity.Finish
End Sub

''Set the Background property of the Activity to the GradientDrawable.
''Returns false if less than two colors are in the array otherwise returns true.
''Orientation can be one of the following - 
''"TOP_BOTTOM", "TR_BL" (Top-Right To Bottom-Left, "RIGHT_LEFT", "BR_TL" (Bottom-Right To Top-Left)
''"BOTTOM_TOP", "BL_TR" (Bottom-Left To Top-Right), "LEFT_RIGHT", "TL_BR" (Top-Left To Bottom-Right)
Sub SetActivityBackground(orientation As String, radius As String, colorsarrayname As String)
	Dim cols(0) As String
	Dim g As GradientDrawable
	cols = Blib.GetArray(colorsarrayname)
	If cols.Length >= 2 Then
		Dim colints(cols.Length) As Int
		For i = 0 To cols.Length - 1
			colints(i) = cols(i)
		Next
		g.Initialize(orientation, colints)
		g.CornerRadius = radius
		Activity.Background = g
		Return True
	End If
	Return False
End Sub

''Logs the provided message to the Logcat output.
Sub LogCat(message As String)
	Log(message)
End Sub

'' Closes the Activity menu. This is added for symmetry with OpenMenu but seems of little practical use.
Sub CloseMenu
	Activity.CloseMenu
End Sub

'' Opens the Activity menu
Sub OpenMenu
	Activity.OpenMenu
End Sub

#End Region

#Region Views and Events
''<a href="#top">Contents</a>
''<a name="events"></a>
''VIEWS AND EVENTS
''
''On Activity_Create the inital block of code up to the first Sub statement is run. GetFirstTime returns true the first time.
''On Activity_Pause "Sub activity_pause(userclosed)" is called if implemented.
''On Activity_Resume "Sub activity_resume" is called if implemented.
''All MenuItem Click events are vectored to a single BasicLib sub "Sub menu_click(menutext)".
''All Button Click events are vectored to a single BasicLib sub "Sub button_click(sender)".
''All Checkbox CheckedChange events are vectored to a single BasicLib sub "Sub check_change(sender, checked)".
''All EditText TextChanged events are vectored to a single BasicLib sub "Sub edit_change(sender, oldtext, newtext)".
''All EditText EnterPressed events are vectored to a single BasicLib sub "Sub edit_enterpressed(sender)".
''All ListView ItemClick events are vectored to a single BasicLib sub "Sub listview_itemclick(sender, position, value)".
''All RadioButton CheckedChange events are vectored to a single BasicLib sub "Sub radio_change(sender, checked)".
''All SeekBar ValueChanged events are vectored to a single BasicLib sub "Sub seekbar_valuechanged(sender, value, userchanged)".
''All Spinner ItemClick events are vectored to a single BasicLib sub "Sub spinner_itemclick(sender, position, value)".
''All TabHost TabChanged events are vectored to a single BasicLib sub "Sub tabhost_tabchanged(sender)".
''All ToggleButton CheckedChange events are vectored to a single BasicLib sub "Sub toggle_change(sender, checked)".
''Sender will be set to the name of view that caused the event.
''If a view raising events is added then the appropriate event Sub or Subs must be present in the program.

#Region Sub templates
''
''Here are all the event Sub templates to copy and paste if desired.
''
''Sub activity_pause(userclosed) 
''End Sub
''
''Sub activity_resume
''End Sub 
''
''Sub button_click(who)
''End Sub 
''
''Sub check_change(who, checked)
''End Sub 
''
''Sub edit_change(who, old, new)
''End Sub
''
''Sub edit_enterpressed(who)
''End Sub
''
''Sub listview_itemclick(who, pos, value)
''End Sub
''
''Sub menu_click(menutext)
''End Sub
''
''Sub radio_change(who, checked)
''End Sub 
''
''Sub seekbar_valuechanged(who, pos, value)
''End Sub
''
''Sub spinner_itemclick(who, pos, value)
''End Sub
''
''Sub tabhost_tabchanged(who)
''End Sub 
''
''Sub toggle_change(who, checked)
''End Sub 
''
#End Region

#Region Menu events

Sub Menu_Click
	If Blib.CanCall("Menu_Click") Then
		Dim params(1) As String
		params(0) = Sender
		Blib.Call("Menu_Click", params)
	End If	
End Sub


#End Region

''Completely remove the named view from the program.
Sub RemoveView(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.RemoveView
	End If
	viewmap.Remove(name)
End Sub

''Add a MenuItem to the Activity.
''The maximum of six menu itemsthat was present in previous versions no longer applies
Sub AddMenuItem(menutext As String)
		Activity.AddMenuItem(menutext, "Menu")
End Sub

''Add a Button to the window or a panel.
Sub AddButton(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim b As Button
	b.Initialize("Button")
	b.Tag = name
	AddView(b, name, left, top, width, height, parent)
End Sub

'Call the script "Sub button_click(sender)" when any Button Click event is raised. 
Sub Button_Click
	Dim v As View
	v = Sender	
	Dim params(1) As String
	params(0) = v.Tag
	Blib.Call("button_click", params)
End Sub

''Add a ToggleButton to the window or a panel.
Sub AddToggleButton(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim b As ToggleButton
	b.Initialize("ToggleButton")
	b.Tag = name	
	AddView(b, name, left, top, width, height, parent)
End Sub

'Call the script "Sub toggle_change(sender, checked)" when any ToggleButton CheckedChanged event is raised 
Sub ToggleButton_CheckedChange(Checked As Boolean)
	Dim v As View
	v = Sender	
	Dim params(2) As String
	params(0) = v.Tag
	params(1) = Checked
	Blib.Call("toggle_change", params)
End Sub

''Add a CheckBox to the window.
Sub AddCheckBox(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim b As CheckBox
	b.Initialize("CheckBox")
	b.Tag = name	
	AddView(b, name, left, top, width, height, parent)
End Sub

'Call the script "Sub check_change(sender, checked)" when any CheckBox CheckedChanged event is raised 
Sub CheckBox_CheckedChange(Checked As Boolean)
	Dim v As View
	v = Sender	
	Dim params(2) As String
	params(0) = v.Tag
	params(1) = Checked
	Blib.Call("check_change", params)
End Sub

''Add an EditText to the window or a panel.
Sub AddEditText(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim e As EditText
	e.Initialize("EditText")
	e.Tag = name
	e.Gravity = Gravity.NO_GRAVITY
	AddView(e, name, left, top, width, height, parent)
End Sub

'Call the script "Sub edit_change(sender, oldtext, newtext)" when any EditText TextChanged event is raised 
Sub EditText_TextChanged (Old As String, New As String)
	Dim v As View
	v = Sender	
	Dim params(3) As String
	params(0) = v.Tag
	params(1) = Old
	params(2) = New	
	Blib.Call("edit_change", params)
End Sub	

'Call the script "Sub edit_enterpressed(sender)" when any EditText EnterPressed event is raised 
Sub EditText_EnterPressed(Old As String, New As String)
	Dim v As View
	v = Sender	
	Dim params(1) As String
	params(0) = v.Tag
	Blib.Call("edit_enterpressed", params)
End Sub	

''Add an ImageView to the window or a panel.
Sub AddImage(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim i As ImageView
	i.Initialize("Image")
	i.Tag = name	
	AddView(i, name, left, top, width, height, parent)
	viewmap.Put(name, i)
End Sub

''Add a Label to the window or a panel.
Sub AddLabel(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim l As Label
	l.Initialize("Label")
	l.Tag = name	
	AddView(l, name, left, top, width, height, parent)
End Sub

''Add a ListView to the window or a panel.
Sub AddListView(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim S As ListView
	S.Initialize("ListView")
	S.Tag = name	
	AddView(S, name, left, top, width, height, parent)
End Sub

'Call the script "Sub listview_itemclick(sender, position, value)" when any ListView ItemClick event is raised 
Sub ListView_ItemClick(position As Int, value As Object)
	Dim v As View
	v = Sender	
	Dim params(3) As String
	params(0) = v.Tag
	params(1) = position
	params(2) = value
	Blib.Call("listview_itemclick", params)
End Sub

''Add a Panel to the window or a panel.
Sub AddPanel(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim p As Panel
	p.Initialize("Panel")
	p.Tag = name	
	AddView(p, name, left, top, width, height, parent)
End Sub

''Add a RadioButton to the window or a panel.
Sub AddRadioButton(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim b As RadioButton
	b.Initialize("RadioButton")
	b.Tag = name	
	AddView(b, name, left, top, width, height, parent)
End Sub

'Call the script "Sub radio_change(sender, checked)" when any RadioButton CheckedChanged event is raised 
Sub RadioButton_CheckedChange(Checked As Boolean)
	Dim v As View
	v = Sender	
	Dim params(2) As String
	params(0) = v.Tag
	params(1) = Checked
	Blib.Call("radio_change", params)
End Sub

''Add a ScrollView to the window or a panel.
Sub AddScrollView(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim S As ScrollView
	S.Initialize(height)
	S.Tag = name	
	AddView(S, name, left, top, width, height, parent)
End Sub

''Add a SeekBar to the window or a panel.
Sub AddSeekBar(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim S As SeekBar
	S.Initialize("SeekBar")
	S.Tag = name	
	AddView(S, name, left, top, width, height, parent)
End Sub

'Call the script "Sub seekbar_valuechanged(sender, value, userchanged)" when any SeekBar ValueChanged event is raised 
Sub SeekBar_ValueChanged(value As Int, userchanged As Boolean)
	Dim v As View
	v = Sender	
	Dim params(3) As String
	params(0) = v.Tag
	params(1) = value
	params(2) = userchanged
	Blib.Call("seekbar_valuechanged", params)
End Sub

''Add a Spinner to the window or a panel.
Sub AddSpinner(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim S As Spinner
	S.Initialize("Spinner")
	S.Tag = name	
	AddView(S, name, left, top, width, height, parent)
End Sub

'Call the script "Sub spinner_itemclick(sender, position, value)" when any Spinner ItemClick event is raised 
Sub Spinner_ItemClick(position As Int, value As Object)
	Dim v As View
	v = Sender	
	Dim params(3) As String
	params(0) = v.Tag
	params(1) = position
	params(2) = value
	Blib.Call("spinner_itemclick", params)
End Sub

''Add a TabHost to the window or a panel.
Sub AddTabHost(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim t As TabHost
	t.Initialize("TabHost")
	t.Tag = name	
	AddView(t, name, left, top, width, height, parent)
End Sub

'Call the script "Sub tabhost_tabchanged(Sender)" when any TabHost TabChanged event is raised 
Sub TabHost_TabChanged
	Dim v As TabHost
	v = Sender	
	Dim params(1) As String
	params(0) = v.Tag
	Blib.Call("tabhost_tabchanged", params) ''Sub tabhost_tabchanged(who)
End Sub

#End Region

#Region View functions
''<a href="#top">Contents</a>
''<a name="view"></a>
''VIEW FUNCTIONS
''
''Get the Enabled property of the named view.
Sub GetEnabled(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		Return v.Enabled
	End If
End Sub

''Get the Visible property of the named view.
Sub GetVisible(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		Return v.Visible
	End If
End Sub

''Get the Top property of the named view.
Sub GetTop(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		Return v.Top
	End If
End Sub

''Get the Left property of the named view.
Sub GetLeft(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		Return v.Left
	End If
End Sub

''Get the Width property of the named view.
Sub GetWidth(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		Return v.Width
	End If
End Sub

''Get the Height property of the named view.
Sub GetHeight(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		Return v.Height
	End If
End Sub

''Set the Enabled property of the named view.
Sub SetEnabled(name As String, state As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.Enabled = state
	End If
End Sub

''Set the Visible property of the named view.
Sub SetVisible(name As String, visible As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.visible = visible
	End If
End Sub

''Set the Top property of the named view.
Sub SetTop(name As String, top As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.top = top
	End If
End Sub

''Set the Left property of the named view.
Sub SetLeft(name As String, left As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.left = left
	End If
End Sub

''Set the Width property of the named view.
Sub SetWidth(name As String, width As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.width = width
	End If
End Sub

''Set the Height property of the named view.
Sub SetHeight(name As String, height As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.height = height
	End If
End Sub

''Bring the named view to the front of the Z order.
Sub BringToFront(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.BringToFront
	End If
End Sub

''Send the named view to the back of the Z order.
Sub SendToBack(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.SendToBack
	End If
End Sub

''Set the focus to  the named view.
Sub RequestFocus(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.RequestFocus
	End If
End Sub

''Set the BackgroundImage of the view to the present bitmap.
''Return true if both view and bitmap are initialised otherwise return false.
Sub SetBackgroundImage(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND bmp.IsInitialized Then
		v.SetBackgroundImage(bmp)
		Return True
	End If
	Return False
End Sub

''Set the Background property of the named view to a ColorDrawable.
Sub SetColor(name As String, radius As String, color As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		Dim c As ColorDrawable
		c.Initialize(color, radius)
		v.Background = c
	End If
End Sub

''Set the Background property of the named view to a GradientDrawable.
''Returns false if less than two colors are in the array or name not found otherwise returns true.
''Orientation can be one of the following - 
''"TOP_BOTTOM", "TR_BL" (Top-Right To Bottom-Left, "RIGHT_LEFT", "BR_TL" (Bottom-Right To Top-Left)
''"BOTTOM_TOP", "BL_TR" (Bottom-Left To Top-Right), "LEFT_RIGHT", "TL_BR" (Top-Left To Bottom-Right)
Sub SetBackground(name As String, orientation As String, radius As String, colorsarrayname As String)
	Dim v As View
	Dim cols(0) As String
	Dim g As GradientDrawable
	v = viewmap.Get(name)
	cols = Blib.GetArray(colorsarrayname)
	If v.IsInitialized AND cols.Length >= 2 Then
		Dim colints(cols.Length) As Int
		For i = 0 To cols.Length - 1
			colints(i) = cols(i)
		Next
		g.Initialize(orientation, colints)
		g.CornerRadius = radius
		v.Background = g
		Return True
	End If
	Return False
End Sub

''Invalidate the named view
Sub Invalidate(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.Invalidate
	End If
End Sub

#End Region

#Region TextView functions
''<a href="#top">Contents</a>
''<a name="textview"></a>
''TEXTVIEW FUNCTIONS
''
''Views containing text support these functions in addition to the View functions.
''

''Set the Gravity property, if any, of the named view.
''NO_GRAVITY = 0; TOP = 48 (0x30) ; BOTTOM = 80 (0x50; LEFT = 3; RIGHT = 5; CENTER = 17 (0x11);
''CENTER_HORIZONTAL = 1; CENTER_VERTICAL = 16 (0x10) ; FILL = 119 (0x77); 
Sub SetGravity(name As String, gravityvalue As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is Label Then
		Dim l As Label
		l = v
		l.Gravity = gravityvalue			
	End If
End Sub

''Get the Text property, if any, of the named view.
Sub GetText(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is Label Then
		Dim l As Label
		l = v
		Return l.Text
	End If
End Sub

''Set the Text property, if any, of the named view.
Sub SetText(name As String, text As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is Label Then
		Dim l As Label
		l = v
		l.text = text			
	End If
End Sub

''Set the TextColor property, if any, of the named view.
Sub SetTextColor(name As String, color As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is Label Then
		Dim l As Label
		l = v
		l.TextColor = color
	End If
End Sub

''Set the TextSize property, if any, of the named view.
Sub SetTextSize(name As String, size As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is Label Then
		Dim l As Label
		l = v
		l.TextSize = size	
	End If
End Sub

''There is one Typeface but it can be reinitialised as required.
''Typeface - "Default", "Monospace", "Serif", "Sans_Serif"
''Style - 0 Normal : 1 Bold : 2 Italic : 3 Bold_Italic
Sub CreateTypeface(face As String, style As String)
	If face = "monospace" Then
		font = Typeface.CreateNew(Typeface.MONOSPACE, style)
	Else If face = "serif" Then
		font = Typeface.CreateNew(Typeface.SERIF, style)
	Else If face = "sans_serif" Then
		font = Typeface.CreateNew(Typeface.SANS_SERIF, style)
	Else 
		font = Typeface.CreateNew(Typeface.DEFAULT, style)
	End If
End Sub

''Set the Typeface property, if any, of the named view to the current typeface.
Sub SetTypeface(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is Label Then
		Dim l As Label
		l = v
		l.Typeface = font	
	End If
End Sub

#End Region

#Region EditText functions
''<a href="#top">Contents</a>
''<a name="edittext"></a>
''EDITTEXT FUNCTIONS
''
''EditText supports these functions in addition to the View and TextView functions.
''
''Gets the selection start position (or the cursor position) of the EditText.
''Returns -1 if there is no selection or cursor.
Sub GetSelectionStart(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is EditText Then
		Dim e As EditText
		e = v
		Return e.SelectionStart		
	End If
End Sub


''Force the EditText virtual keyboard action key to display Done by setting this value to True.
Sub SetForceDoneButton(name As String, forcestate As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is EditText Then
		Dim e As EditText
		e = v
		e.ForceDoneButton = forcestate			
	End If
	
End Sub

''Set the text that will appear when the EditText is empty.
Sub SetHint(name As String, hint As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is EditText Then
		Dim e As EditText
		e = v
		e.hint = hint			
	End If
	
End Sub

''Set the color of the text that will appear when the EditText is empty.
Sub SetHintColor(name As String, hintcolor As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is EditText Then
		Dim e As EditText
		e = v
		e.hintcolor = hintcolor			
	End If
End Sub

''Set the value of the EditText InputType property.
''NONE = 0; TEXT = 1; NUMBERS = 2; _PHONE = 3; DECIMAL_NUMBERS = 12290;
Sub SetInputType(name As String, inputtype As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is EditText Then
		Dim e As EditText
		e = v
		e.inputtype = inputtype			
	End If
End Sub

''Set the value of the EditText PasswordMode property.
Sub SetPasswordMode(name As String, state As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is EditText Then
		Dim e As EditText
		e = v
		e.PasswordMode = state			
	End If
End Sub

''Sets the selection start position (or the cursor position) of the EditText.
Sub SetSelectionStart(name As String, selectionstart As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is EditText Then
		Dim e As EditText
		e = v
		e.selectionstart = selectionstart			
	End If
End Sub

''Set the value of the EditText SingleLine property.
Sub SetSingleLine(name As String, state As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is EditText Then
		Dim e As EditText
		e = v
		e.SingleLine = state			
	End If
End Sub

''Set the value of the EditText Wrap property.
Sub SetWrap(name As String, state As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is EditText Then
		Dim e As EditText
		e = v
		e.Wrap = state			
	End If
End Sub


#End Region

#Region CheckBox, RadioButton and ToggleButton functions
''<a href="#top">Contents</a>
''<a name="check"></a>
''CHECKBOX, RADIOBUTTON AND TOGGLEBUTTON FUNCTIONS
''

''Get the Checked state of a CheckBox, RadioButton or ToggleButton.
Sub GetChecked(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		If v Is CheckBox Then
			Dim c As CheckBox
			c = v
			Return c.Checked
		Else If v Is RadioButton Then
			Dim r As RadioButton
			r = v
			Return r.Checked
		Else If v Is ToggleButton Then
			Dim t As ToggleButton
			t = v
			Return t.Checked
		End If
	End If
End Sub

''Set the Checked state of a CheckBox, RadioButton or ToggleButton.
Sub SetChecked(name As String, checked As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		If v Is CheckBox Then
			Dim c As CheckBox
			c = v
			c.checked = checked
		Else If v Is RadioButton Then
			Dim r As RadioButton
			r = v
			r.checked = checked		
		Else If v Is ToggleButton Then
			Dim t As ToggleButton
			t = v
			t.checked = checked		
		End If
	End If
End Sub

''Set the TextOn property of a ToggleButton.
Sub SetTextOn(name As String, text As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is ToggleButton Then
		Dim b As ToggleButton
		b = v
		b.TextOn = text			
	End If
End Sub

''Set the TextOff property property of a ToggleButton.
Sub SetTextOff(name As String, text As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is ToggleButton Then
		Dim b As ToggleButton
		b = v
		b.TextOff = text			
	End If
End Sub

#End Region

#Region Timer functions
''<a href="#top">Contents</a>
''<a name="timer"></a>
''TIMER FUNCTIONS
''
''There is one time and the Timer Tick events are vectored to a BasicLib sub "Sub timer_tick".
''If the Timer is enabled this event Sub must be present in the program.
''
''Enable or disable the timer.
Sub SetTimerEnabled(enabled As String)
	timer1.enabled = enabled
End Sub

''Set the timer interval in milliseconds.
Sub SetTimerInterval(interval As String)
	timer1.interval = interval
End Sub

'Call the script "Sub timer_tick" when the timer Tick event is raised 
Sub Timer_Tick
	Dim params(0) As String
	Blib.Call("timer_tick", params)
End Sub

#End Region

#Region SeekBar functions
''<a href="#top">Contents</a>
''<a name="seekbar"></a>
''SEEKBAR FUNCTIONS
''

''Returns the current SeekBar Max value.
Sub GetMax(seekbarname As String)
	Dim v As View
	v = viewmap.Get(seekbarname)
	If v.IsInitialized AND v Is SeekBar Then
		Dim S As SeekBar
		S = v
		Return S.Max
	End If
End Sub

''Returns the current SeekBar Value.
Sub GetValue(seekbarname As String)
	Dim v As View
	v = viewmap.Get(seekbarname)
	If v.IsInitialized AND v Is SeekBar Then
		Dim S As SeekBar
		S = v
		Return S.Value
	End If
End Sub

''Sets the current SeekBar Max value.
Sub SetMax(seekbarname As String, maxvalue As String)
	Dim v As View
	v = viewmap.Get(seekbarname)
	If v.IsInitialized AND v Is SeekBar Then
		Dim S As SeekBar
		S = v
		S.Max = maxvalue
	End If
End Sub

''Sets the current SeekBar Value.
Sub SetValue(seekbarname As String, value As String)
	Dim v As View
	v = viewmap.Get(seekbarname)
	If v.IsInitialized AND v Is SeekBar Then
		Dim S As SeekBar
		S = v
		S.value = value
	End If
End Sub

#End Region

#Region ScrollView functions
''<a href="#top">Contents</a>
''<a name="scrollview"></a>
''SCROLLVIEW FUNCTIONS
''

''Returns the current ScrollView ScrollPosition.
Sub GetScrollPosition(scrollviewname As String)
	Dim v As View
	v = viewmap.Get(scrollviewname)
	If v.IsInitialized AND v Is ScrollView Then
		Dim S As ScrollView
		S = v
		Return S.ScrollPosition
	End If
End Sub

''Sets the current ScrollView ScrollPosition.
Sub SetScrollPosition(scrollviewname As String, value As String)
	Dim v As View
	v = viewmap.Get(scrollviewname)
	If v.IsInitialized AND v Is ScrollView Then
		Dim S As ScrollView
		S = v
		S.ScrollPosition = value
	End If
End Sub

''Scrolls the ScrollView to the top or bottom.
Sub FullScroll(scrollviewname As String, bottom As String)
	Dim v As View
	v = viewmap.Get(scrollviewname)
	If v.IsInitialized AND v Is ScrollView Then
		Dim S As ScrollView
		S = v
		S.FullScroll(bottom)
	End If
End Sub

''Makes the ScrollView Panel accessible as a named Panel View.
Sub GetPanel(scrollviewname As String, panelname As String)
	Dim v As View
	v = viewmap.Get(scrollviewname)
	If v.IsInitialized AND v Is ScrollView Then
		Dim S As ScrollView
		S = v
		viewmap.Put(panelname, S.Panel)
	End If
End Sub

#End Region

#Region Spinner functions
''<a href="#top">Contents</a>
''<a name="spinner"></a>
''SPINNER FUNCTIONS
''

''Sets the title that will be displayed when the Spinner is opened.
Sub SetPrompt(name As String, index As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized  AND v Is Spinner Then
		Dim S As Spinner
		S = v
		S.Prompt = index
	End If
End Sub

''Returns the index of the selected item of a Spinner. Returns -1 if no item is selected.
Sub GetSelectedIndex(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is Spinner Then
		Dim S As Spinner
		S = v
		Return S.SelectedIndex
	End If
End Sub

''Selects the item at the specified index of a Spinner. Pass -1 if no item is selected.
Sub SetSelectedIndex(name As String, index As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is Spinner Then
		Dim S As Spinner
		S = v
		S.SelectedIndex = index
	End If
End Sub

''Returns the the selected item of a Spinner. Returns "" if no item is selected.
Sub GetSelectedItem(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is Spinner Then
		Dim S As Spinner
		S = v
		Return S.SelectedItem
	End If
End Sub

#End Region

#Region ListView functions
''<a href="#top">Contents</a>
''<a name="listview"></a>
''LISTVIEW FUNCTIONS
''

''Sets the background color that will be used while scrolling the ListView.
Sub SetScrollColor(name As String, color As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is ListView Then
		Dim l As ListView
		l = v
		l.ScrollingBackgroundColor = color		
	End If
End Sub

''Sets whether the fast scroll icon will appear when the user scrolls the list. The default Is False.
Sub SetFastScrollEnabled(name As String, state As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is ListView Then
		Dim l As ListView
		l = v
		l.FastScrollEnabled = state		
	End If
End Sub

''Sets the ItemHeight of the SingleLineLayout in a ListView.
Sub SetItemHeight(name As String, height As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is ListView Then
		Dim l As ListView
		l = v
		l.SingleLineLayout.ItemHeight = height		
	End If
End Sub

''Makes the ListView.SingleLineLayout.Label accessible as a Label view.
''The layout functions of the ListView items may be changed using the label functions.
Sub GetLabel(listviewname As String, labelname As String)
	Dim v As View
	v = viewmap.Get(listviewname)
	If v.IsInitialized AND v Is ListView Then
		Dim l As ListView
		l = v
		viewmap.Put(labelname, l.SingleLineLayout.Label)
	End If
End Sub

''Set the ListView.SingleLineLayout.Background property of the ListView to a ColorDrawable.
Sub SetLayoutBackgroundColor(name As String, radius As String, color As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is ListView Then
		Dim c As ColorDrawable
		c.Initialize(color, radius)
		Dim l As ListView
		l.SingleLineLayout.Background = c
	End If
End Sub

''Set the ListView.SingleLineLayout.Background property of the ListView to a GradientDrawable.
''Returns false if less than two colors are in the array or name not found otherwise returns true.
''Orientation can be one of the following - 
''"TOP_BOTTOM", "TR_BL" (Top-Right To Bottom-Left, "RIGHT_LEFT", "BR_TL" (Bottom-Right To Top-Left)
''"BOTTOM_TOP", "BL_TR" (Bottom-Left To Top-Right), "LEFT_RIGHT", "TL_BR" (Top-Left To Bottom-Right)
Sub SetLayoutBackgroundColorgradient(name As String, orientation As String, radius As String, colorsarrayname As String)
	Dim cols(0) As String
	Dim v As View
	v = viewmap.Get(name)
	cols = Blib.GetArray(colorsarrayname)
	If v.IsInitialized AND v Is ListView AND cols.Length >= 2 Then
		Dim l As ListView
		Dim g As GradientDrawable
		Dim colints(cols.Length) As Int
		For i = 0 To cols.Length - 1
			colints(i) = cols(i)
		Next
		g.Initialize(orientation, colints)
		g.CornerRadius = radius
		l = v
		l.SingleLineLayout.Background = g
		Return True
	End If
	Return False
End Sub

#End Region

#Region ListView and Spinner functions
''<a href="#top">Contents</a>
''<a name="listandspin"></a>
''LISTVIEW AND SPINNER FUNCTIONS
''

''Add an item To a ListView or Spinner.
Sub Add(name As String, item As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		If v Is Spinner Then
			Dim S As Spinner
			S = v
			S.Add(item)
		Else If v Is ListView Then
			Dim l As ListView
			l = v
			l.AddSingleLine(item)		
		End If
	End If
End Sub

''Add an array of items to a ListView or Spinner.
Sub AddAll(name As String, itemarrayname As String)
	Dim v As View
	Dim ia(0) As String
	v = viewmap.Get(name)
	If v.IsInitialized Then
		If v Is Spinner Then
			Dim S As Spinner
			S = v
			ia = Blib.GetArray(itemarrayname)
			S.AddAll(ia)
		Else If v Is ListView Then
			Dim l As ListView
			l = v
			ia = Blib.GetArray(itemarrayname)
			For i = 0 To ia.Length - 1
				l.AddSingleLine(ia(i))
			Next
		End If
	End If
End Sub

''Clears the items from a ListView or Spinner.
Sub Clear(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		If v Is Spinner Then
			Dim S As Spinner
			S = v
			S.Clear
		Else If v Is ListView Then
			Dim l As ListView
			l = v
			l.Clear
		End If
	End If
End Sub

''Returns the item at the specified index from a ListView or Spinner.
Sub GetItem(name As String, index As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		If v Is Spinner Then
			Dim S As Spinner
			S = v
			Return S.GetItem(index)
		Else If v Is ListView Then
			Dim l As ListView
			l = v
			Return l.GetItem(index)
		End If
	End If
End Sub

''Removes the item at the specified index from a ListView or Spinner.
Sub RemoveAt(name As String, index As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		If v Is Spinner Then
			Dim S As Spinner
			S = v
			S.RemoveAt(index)
		Else If v Is ListView Then
			Dim l As ListView
			l = v
			l.RemoveAt(index)
		End If
	End If
End Sub

''Returns the number of items in a ListView or Spinner.
Sub GetSize(name As String, index As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		If v Is Spinner Then
			Dim S As Spinner
			S = v
			Return S.Size
		Else If v Is ListView Then
			Dim l As ListView
			l = v
			Return l.Size
		End If
	End If
End Sub

#End Region

#Region TabHost functions
''<a href="#top">Contents</a>
''<a name="tabhost"></a>
''TABHOST
''

''Add a Tab and a new associated Panel to a TabHost.
''The panelname may be used to add views To the Tab.
Sub AddTab(title As String, panelname As String, parenttabhost As String)
	Dim v As View
	v = viewmap.Get(parenttabhost)
	If v.IsInitialized AND v Is TabHost Then
		Dim t As TabHost
		t = v
		Dim p As Panel
		p.Initialize("Panel")
		p.Tag = panelname	
		viewmap.Put(panelname, p)			
		t.AddTab2(title, p)
	End If
End Sub

''Returns the number of tab pages.
Sub GetTabCount(tabhostname As String)
	Dim v As View
	v = viewmap.Get(tabhostname)
	If v.IsInitialized AND v Is TabHost Then
		Dim t As TabHost
		t = v
		Return t.TabCount
	End If
End Sub

''Returns the index of the current tab page.
Sub GetCurrentTab(tabhostname As String)
	Dim v As View
	v = viewmap.Get(tabhostname)
	If v.IsInitialized AND v Is TabHost Then
		Dim t As TabHost
		t = v
		Return t.CurrentTab
	End If
End Sub

''Selects the current tab page.
Sub SetCurrentTab(tabhostname As String, tabnumber As String)
	Dim v As View
	v = viewmap.Get(tabhostname)
	If v.IsInitialized AND v Is TabHost Then
		Dim t As TabHost
		t = v
		t.CurrentTab = tabnumber
	End If
End Sub

#End Region

#Region Graphics functions
''<a href="#top">Contents</a>
''<a name="graphics"></a>
''GRAPHICS FUNCTIONS
''

''There is one bitmap but it can be reinitialised to a bitmap from a file.
Sub BitmapInit(dir As String, fileName As String)
	bmp.Initialize(dir, fileName)
End Sub

''The one bitmap can also be reinitialised to a mutable bitmap.
Sub BitmapInitMutable(width As String, height As String)
	bmp.InitializeMutable(width, height)
End Sub

''Get the width of the current bitmap.
Sub BitmapWidth
	Return bmp.Width
End Sub

''Get the height of the current bitmap.
Sub BitmapHeight
	Return bmp.Height
End Sub

''There is one canvas but it can be reinitialised on any View.
Sub CanvasInit(imageviewname As String)
	Dim v As View
	v = viewmap.Get(imageviewname)
	If v.IsInitialized Then
		draw.Initialize(v)
	End If
End Sub

''The one canvas can also be reinitialised on a mutable Bitmap if the sole Bitmap object is one.
Sub CanvasInit2()
	Dim v As View
	If bmp.IsInitialized Then
		draw.Initialize2(bmp)
	End If
End Sub

''Draws the present bitmap
''SrcRect - The subset of the Bitmap that will be drawn.
''DestRect - The rectangle that the Bitmap will be drawn to.
''Returns false if more or less than two points are in the rectangle arrays otherwise returns true.
Sub DrawBitmap(srcrectarrayname As String, destrectarrayname As String)
	Dim rsrc As Rect
	Dim rdest As Rect
	Dim rs(0) As String
	Dim rd(0) As String
	rs = Blib.GetArray(srcrectarrayname)
	rd = Blib.GetArray(destrectarrayname)
	If rs.Length <> 4 OR rd.Length <> 4 Then
		Return False
	End If
	rsrc.Initialize(rs(0), rs(1), rs(2), rs(3))
	rdest.Initialize(rd(0), rd(1), rd(2), rd(3))
	draw.DrawBitmap(bmp, rsrc, rdest)
	Return True
End Sub

''Draws the present bitmap rotated.
''SrcRect - The subset of the Bitmap that will be drawn.
''DestRect - The rectangle that the Bitmap will be drawn to.
''Returns false if more or less than two points are in the rectangle arrays otherwise returns true.
Sub DrawBitmapRotated(srcrectarrayname As String, destrectarrayname As String, degrees As String)
	Dim rsrc As Rect
	Dim rdest As Rect
	Dim rs(0) As String
	Dim rd(0) As String
	rs = Blib.GetArray(srcrectarrayname)
	rd = Blib.GetArray(destrectarrayname)
	If rs.Length <> 4 OR rd.Length <> 4 Then
		Return False
	End If
	rsrc.Initialize(rs(0), rs(1), rs(2), rs(3))
	rdest.Initialize(rd(0), rd(1), rd(2), rd(3))
	draw.DrawBitmapRotated(bmp, rsrc, rdest, degrees)
	Return True
End Sub

''Fills the entire canvas with the given color.
Sub DrawColor(color As String)
	draw.DrawColor(color)
End Sub

''Draws a circle.
Sub DrawCircle(x As String, y As String, radius As String, color As String, filled As String, strokewidth As String)
	draw.DrawCircle(x, y, radius, color, filled, strokewidth)
	End Sub

''Draws a line.
Sub DrawLine(x1 As String, y1 As String, x2 As String, y2 As String, color As String, strokewidth As String)
	draw.DrawLine(x1, y1, x2, y2, color, strokewidth)
End Sub

''Draws a set of connected lines from the points provided in a named array.
''Returns false if less than two points are in the array otherwise returns true.
Sub DrawPath(pointsarrayname As String, color As String, filled As String, strokewidth As String)
	Dim p As Path
	Dim pts(0) As String
	pts = Blib.GetArray(pointsarrayname)
	If pts.Length < 4 Then
		Return False
	End If
	p.Initialize(pts(0), pts(1))
	For i = 2 To pts.Length - 2 Step 2
		p.LineTo(pts(i), pts(i + 1))
	Next
	draw.DrawPath(p, color, filled, strokewidth)
	Return True
End Sub

''Sets a single pixel to the specified color.
Sub DrawPoint(x As String, y As String, Color As String)
	draw.DrawPoint(x, y, Color)
End Sub

''Draws a rectangle from the points provided in a named array.
''Returns false if more or less than two points are in the array otherwise returns true.
Sub DrawRect(rectarrayname As String, color As String, filled As String, strokewidth As String)
	Dim r As Rect
	Dim ra(0) As String
	ra = Blib.GetArray(rectarrayname)
	If ra.Length <> 4 Then
		Return False
	End If
	r.Initialize(ra(0), ra(1), ra(2), ra(3))
	draw.DrawRect(r, color, filled, strokewidth)
	Return True
End Sub

''Draws a rotated rectangle from the points provided in a named array.
''Returns false if more or less than two points are in the array otherwise returns true.
Sub DrawRectRotated(rectarrayname As String, color As String, filled As String, strokewidth As String, degrees As String)
	Dim r As Rect
	Dim ra(0) As String
	ra = Blib.GetArray(rectarrayname)
	If ra.Length <> 4 Then
		Return False
	End If
	r.Initialize(ra(0), ra(1), ra(2), ra(3))
	draw.DrawRectRotated(r, color, filled, strokewidth, degrees)
	Return True
End Sub

''Draw text. Align is one of the following values: "LEFT", "CENTER", "RIGHT".
Sub DrawText(text As String, x As String, y As String, textsize As String, color As String, align As String)
	draw.DrawText(text, x, y, font, textsize, color, align.ToUpperCase)
End Sub

''Draw text. Align is one of the following values: "LEFT", "CENTER", "RIGHT".
Sub DrawTextRotated(text As String, x As String, y As String, textsize As String, color As String, align As String, degrees As String)
	draw.DrawTextRotated(text, x, y, font, textsize, color, align.ToUpperCase, degrees)
End Sub

#End Region

#Region Array Functions
''<a href="#top">Contents</a>
''<a name="arrays"></a>
''ARRAY FUNCTIONS
''

''Fully or partially fills the specified array with the specified value.
Sub FillArray(arrayname As String, start As String, len As String, value As String)
	Dim ia(0) As String
	ia = Blib.GetArray(arrayname)
	arraysX.Fill(ia, start, len, value)
	Blib.ShareArray(arrayname, ia)
End Sub

''Sort the specified array into ascending order in the specified manner. 
''SORTCASESENSITIVE is 0, SORTCASEINSENSITIVE is 1, SORTNUMERIC = 2
''Note that for use with BinarySearch SORTCASESENSITIVE should be used otherwise the result may not be accurate
Sub SortArray(arrayname As String, sorttype As String)
	Dim ia(0) As String
	ia = Blib.GetArray(arrayname)
	arraysX.SortStringArray(ia, sorttype)
	Blib.ShareArray(arrayname, ia)
End Sub

''Searches the specified array for the specified value using the binary search algorithm.
''The array must be sorted into ascending order using SORTCASESENSITIVE otherwise the result may not be accurate
Sub SearchArray(arrayname As String, value As String)
	Dim ia(0), res As String
	ia = Blib.GetArray(arrayname)
	res = arraysX.BinarySearch(ia, value)
	Return res
End Sub



#End Region

#Region User interaction functions
''<a href="#top">Contents</a>
''<a name="user"></a>
''USER INTERACTION FUNCTIONS
''

''Shows a Toast.
Sub ShowToast(msg As String, longtime As String)
	ToastMessageShow(msg, longtime)
End Sub

''Get the user input from the latest InputBox, InputDate or InputTime modal dialog. 
Sub GetInput
	Return input
End Sub

''Show a modal dialog box and prompt the user for data.
''Returns a DialogResponse value with the input text available to GetInput.
Sub InputBox(prompt As String, title As String, Positive As String, Cancel As String, Negative As String)
	Dim i As InputDialog
	response = i.Show(prompt, title, Positive, Cancel, Negative, Null)
	input = i.input
	Return response	
End Sub

''Show a modal dialog box and prompt the user for a date.
''Returns a DialogResponse value with the input value avalable to GetInput as a ticks value.
Sub InputDate(prompt As String, title As String, startdateticks As String, Positive As String, Cancel As String, Negative As String)
	Dim d As DateDialog
	d.DateTicks = startdateticks 
	response = d.Show(prompt, title, Positive, Cancel, Negative, Null)
	input = d.DateTicks
	Return response	
End Sub

''Show a modal dialog box and prompt the user for a path or file name.
''Returns a DialogResponse value with the input values available to GetInput as a  comma separated string.
''The first part is the file path and the last part is file name. If the user selected a path the file name is an  empty string.
Sub InputFile(filepath As String, filename As String, filefilter As String, title As String, Positive As String, Cancel As String, Negative As String)
	Dim f As FileDialog	
	f.filepath = filepath
	f.ChosenName = filename
	f.filefilter = filefilter
	response = f.Show(title, Positive, Cancel, Negative, Null)
	input = f.filepath & "," & f.ChosenName
	Return response	
End Sub

''Show a modal dialog box and prompt the user for a time.
''Returns a DialogResponse value with the input value available to GetInput as a ticks value.
Sub InputTime(prompt As String, title As String, starttimeticks As String, as24hrs As String, Positive As String, Cancel As String, Negative As String)
	Dim t As TimeDialog
	t.TimeTicks = starttimeticks
	t.Is24Hours = as24hrs
	response = t.Show(prompt, title, Positive, Cancel, Negative, Null)
	input = t.TimeTicks
	Return response	
End Sub

''Show a modal dialog box and prompt the user to select an item.
''selecteditem is the index of the item that will first be selected or -1 if no item should be preselected.
''Returns the index of the selected item or DialogResponse.Cancel if the user pressed on the back key.
Sub InputListBox(itemarrayname As String, title As String, selecteditem As String )
	Dim l As List
	l.Initialize
	Dim ia(0) As String
	ia = Blib.GetArray(itemarrayname)
	For i = 0 To ia.Length - 1
		l.Add(ia(i))
	Next
	Return InputList(l, title, selecteditem) 	
End Sub

''Show a modal dialog box and prompt the user to select one or more items.
''returns a comma separated list of indices selected that may be separated with StrSplit.
Sub InputMultiListBox(itemarrayname As String, title As String)
	Dim l As List	
	l.Initialize
	Dim ia(0) As String
	ia = Blib.GetArray(itemarrayname)
	For i = 0 To ia.Length - 1
		l.Add(ia(i))
	Next
	l = InputMultiList(l, title)
	ret = ""
	comma = ""
	For i = 0 To l.Size - 1
		ret = ret & comma & l.Get(i)
		comma = ","
	Next
	Return ret
End Sub

''Show a modal dialog box and prompt the user for an integer number.
''If ShowSign is True the sign of the number corresponds to the sign entered by the user.
''Returns a DialogResponse value with the input number available to GetInput.
''If ShowSign is True the sign of the number corresponds to the sign entered by the user.
Sub InputNumber(showsign As String, digits As String, number As String, title As String, Positive As String, Cancel As String, Negative As String)
	Dim n As NumberDialog
	n.showsign = showsign
	n.digits = digits
	n.number = number
	response = n.Show(title, Positive, Cancel, Negative, Null)
	input = n.number
	Return response	
End Sub

''Show a modal dialog box and prompt the user to make a selection.
''Returns a DialogResponse
Sub MessageBox(message As String, title As String, Positive As String, Cancel As String, Negative As String)
	response = Msgbox2(message, title, Positive, Cancel, Negative, Null)
	Return response	
End Sub

''Show a non-modal progress dialog.
Sub ProgressShow(text As String)
	ProgressDialogShow(text)
End Sub

''Hide a non-modal progress dialog.
Sub ProgressHide
	ProgressDialogHide
End Sub

''Allow the message loop to run, lets the progress dialog repaint itself.
Sub CallDoEvents
	DoEvents
End Sub

#End Region

#Region File operation functions
''<a href="#top">Contents</a>
''<a name="file"></a>
''FILE OPERATION FUNCTIONS
''

''Reads the entire file and fills a named array with all lines as strings.
''Returns true if successful, false otherwise.
Sub FileReadList(dir As String, fileName As String, listarrayname As String)
	Try
		Dim l As List
		l = File.ReadList(dir, fileName)
		Dim A(l.Size) As String
		For i = 0 To A.Length - 1
			A(i) = l.Get(i)
		Next
		Blib.SetArray(listarrayname, A)
		Return True
	Catch
		Return False
	End Try
End Sub

''Reads the entire file and returns it as a string.
''Returns an empty string on failure.
Sub FileReadString(dir As String, fileName As String)
	Try
		Return File.ReadString(dir, fileName)
	Catch
		Return ""
	End Try
End Sub

''Writes each item in the List As a single line.
''Note that a value containing CRLF will be saved as two lines which will return two items when read with ReadList.
''Returns true if successful, false otherwise.
Sub FileWriteList(dir As String, filename As String, listarrayname As String)
	Try
		Dim A(0) As String
		A = Blib.GetArray(listarrayname)
		File.WriteList(dir, filename, A)
		Return True
	Catch
		Return False
	End Try
End Sub

''Writes the given text to a new file.
''Returns true if successful, false otherwise.
Sub FileWriteString(dir As String, filename As String, text As String)
	Try
		File.WriteString(dir, filename, text)
		Return True
	Catch
		Return False
	End Try
End Sub

''Deletes the specified file. If the file name is a directory then it must be empty in order to be deleted.
''Returns true if the file was successfully deleted.
''Files in the assets folder cannot be deleted.
''Returns true if successful, false otherwise.
Sub FileDelete(dir As String, filename As String)
	Try
		Return File.Delete(dir, filename)
	Catch
		Return False
	End Try	
End Sub

''Returns true if the specified FileName exists in the specified Dir.
''Note that the Android file system is case sensitive.
Sub FileExists(dir As String, filename As String)
	Return File.Exists(dir, filename)
End Sub

''Tests whether the specified file is a directory.
Sub FileIsDirectory(dir As String, filename As String)
	Return File.IsDirectory(dir, filename)
End Sub

''Creates the given folder (dir can be a path like "dir1/dir2", creates all folders as needed).
''Returns true if successful, false otherwise.
Sub FileMakeDir(parentdir As String, dir As String)
	Try
		File.MakeDir(parentdir, dir)
		Return True
	Catch
		Return False
	End Try
End Sub 

''Fills an array with a list with all the files and directories which are stored in the specified path.
''Returns true if successful, false otherwise.
Sub FileListFiles(dir As String, filesarrayname As String)
	Try
		Dim l As List
		l = File.ListFiles(dir)
		Dim A(l.Size) As String
		For i = 0 To A.Length - 1
			A(i) = l.Get(i)
		Next
		Blib.SetArray(filesarrayname, A)	
		Return True
	Catch
		Return False
	End Try
End Sub

''Returns the root folder of the external storage media.
Sub FileDirRootExternal
	Return File.DirRootExternal
End Sub

''Returns the application default external folder which is based on the package name.
''The folder is created if needed.
Sub FileDirDefaultExternal
	Return File.DirDefaultExternal
End Sub

''Returns a reference to the files added with the Files Manager. These files are read-only.
Sub FileDirAssets
	Return File.DirAssets
End Sub

''<a href="#top">Contents</a>
#End Region 

#Region Custom functions

'##########################################################################################
' Custom Subs added to be added as functions to BasicLibIDE by AddSysCalls are defined here
' -----------------------------------------------------------------------------------------

' Call once after Blib.Initialize to add the new functions
Sub AddNewSysCalls
	Blib.AddSysCalls(SysCalls.SysWords)
	Blib.AddSysCalls(Array As String("SysTest1", "SysTest2"))
End Sub

' The new functions follow

Sub SysTest1(param1 As String) 
	Return "(1) " & param1
End Sub

Sub SysTest2(param1 As String, param2 As String)
	Return "(1) " & param1 & " (2) " & param2
End Sub

#End Region
